'L1: Global variables and set up
Dim shell, objFSO, objFile1, objFile2                                   ' Objects needed for opening and running files
Dim strApp, strList, strTemp                                               ' Strings to hold names of working files
Dim strInfo, strData                                                             ' Strings to hold contents of files
Dim Pattern(30), strName, strArgs ,Report                           ' Strings to hold variables

strApp= "C:\Program files\Irfanview\i_view32.exe"               'Irfanview location - edit if necessary
D_sep= vbTab                                                                     'Separator set to Tab character (good for Excel)
set_patterns                                                                          'Call subroutine to initialise the Patterns 


Select case Wscript.Arguments.count
Case 0  MsgBox "Error - No parameters" : Wscript.Quit
Case 1   strList=Wscript.Arguments(0)
Case 2   If Wscript.Arguments(0) = "/show" then Report=1 else MsgBox "Option incorrect"
             strList=Wscript.Arguments(1)
Case Else   MsgBox "Too many parameters" :  Wscript.Quit
End Select
If instr("txt|lst|shw", Right(strList,3))=0 then Msgbox strList & " is wrong file type" : Wscript.Quit

Set objFSO = CreateObject("Scripting.FileSystemObject") 	      'Link to Windows File system
Set shell = CreateObject("WScript.Shell")                                       'Link to Windows Shell processes
strTemp= shell.ExpandEnvironmentStrings ("%Temp%") & "\Info.txt"   'Temporary file for IV output
strData="File spec"                                                                        'Start building the output data as a string
For Each strP in Pattern                                                                  'Collect headers from each pattern in turn
   If strP > "" then strData =strData & D_sep & Left(strP,Instr(1,strP,"|")-1)           'Add another heading
Next
Set objFile1 = objFSO.OpenTextFile(strList, 1)	                      'Open file containing list to be processed    
Do While objFile1.AtEndOfStream = False
    strName = objFile1.ReadLine
    If objFSO.FileExists(strName) then Collect_info                            'Check if file exists before collecting info
Loop 
objFile1.Close                                                                                    'Finished reading file
Set objFile1 = objFSO.OpenTextFile(strList, 2)	                      'Re-open file to write data
objFile1.Write strData                                                                       'Replace contents with built up data string
objFile1.Close                                                                                  'Finished with this file
Set shell = Nothing                                                                         'Finished with shell object
Set objFile = Nothing                                                                      'Finished with file system object
wscript.echo "Finished"                                                                  'Notify that job has completed

Sub Collect_info
If report = 1 then wscript.echo "Processing " & strName               'Progress monitor if selected
strBuild = chr(34) & strApp & chr(34) & " " & strName & " /info=" & strTemp & " /fullinfo"      ' IV command
shell.Run strBuild, 2, true                                                                             'Run IV and wait for it to finish
If objFSO.FileExists(strTemp) then Set objFile2 = objFSO.OpenTextFile(strTemp, 1) else exit Sub	                        
strInfo = objFile2.ReadAll                                                                   'and read everything into strInfo
objFile2.Close                                                                                     'Finished with this file
strInfo=Replace(strInfo, vbCrLf, "#")                                     'Replace all CR, LF with #  (easier to find EOL)
strData=strData & vbCrLf & strName                                    'Append name of this file to output data string
For Each strP in Pattern                                                         'Get output data using each pattern in turn
   If strP > "" then strData=strData & Extract()        'Call Extract subroutine and add return data to the string
Next
objFSO.DeleteFile(strTemp)                                   'Delete the temporary Info file
End sub

Function Extract                                            'Extract data from strInfo by matching substrings of Pattern in strP
I_Pt=0                                                                                       'Reset pointer for the data within strInfo
Do until instr(strP, "|") = 0                                                          'Exits loop with final match still left in strP
   strSub =  Left (strP, instr(strP, "|")-1)                                       'Substring to match this time round
   strP = Mid (strP, instr(strP, "|")+1)                                           'Strip off this match and leave remainder in strP
   If I_Pt=0 then I_pt=1 else I_Pt =Instr (I_Pt, strInfo, strSub,1)   'Find match in strInfo or set to 1 if first time
   If I_Pt=0 then Exit Do else I_Pt = I_Pt + len(strSub)                 'Move to after match - exit if match not found
Loop
If I_Pt=0 then Extract = "" else Extract = Trim( Mid(strInfo, I_Pt, instr(I_Pt, strInfo, strP,1)- I_Pt))
Extract = D_sep & Extract
End Function

'Area to set up patterns that show where the required data is located in the Irfanview Info file
'Pattern format is : Header[|match these strings first]|string before data|string after data   (# means End of  a line)
sub set_patterns
'Pattern(0)= "File|#File name|=|#"
'Pattern(1)="Path|#Directory|=|#"
Pattern(2)="Type|#Compression|=|#"
'Pattern(3)="DPI x|#Resolution|=|x"
'Pattern(4)="DPI y|#Resolution|x|DPI"
Pattern(5)="Pixels x|#Image Dimensions|=|x"
Pattern(6)="Pixels y|#Image Dimensions|x|Pix"
Pattern(7)="Height ins|#Print size|;|x"
Pattern(8)="Width ins|#Print size|;|x|in"
Pattern(9)="Colors|#Color depth|=|("
Pattern(10)="Unique|#Number of unique colors|=|#"
Pattern(11)="Size|#Disk size|=|("
Pattern(12)="Memory|#Current memory size|=|("
Pattern(13)="Date|#File date/time|=| / "
Pattern(14)="Time|#File date/time| / |#"
Pattern(15)="Exif Date|#DateTime|- | "
Pattern(16)="Exif Time|#DateTime|- | |#"
Pattern(17)="Orientation|#Orientation|-|#"
End sub
